#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef long long ll;
typedef long double ld;

template <class T> using Tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second

template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}

//DEBUG TEMPLATE POCINJE OVDE

void __print(int x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}

template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
void _print() {cerr << "]\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}

#ifdef ljuba
#define debug(x...) cerr << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x)
#else
#define debug(x...)
#endif

//DEBUG TEMPLATE SE ZAVRSAVA OVDE

const char nl = '\n';

const int mxN = 2e5 + 13;

int n, c, q;
string s;
vpii kveri;

struct node {
    bool marked;
    map<char, int> ma;
}st[4*mxN];

void build(int i = 1, int l2 = 0, int r2 = n-1) {
    if(l2 == r2) {
        st[i].marked = 0;
        st[i].ma[s[l2]]++;
        return;
    }

    int m2 = (l2 + r2) / 2;
    build(2*i, l2, m2);
    build(2*i+1, m2+1, r2);
    st[i].marked = 0;
    st[i].ma = st[2*i].ma;
    st[i].ma['0'] += st[2*i+1].ma['0'];
    st[i].ma['1'] += st[2*i+1].ma['1'];
}

void app(int i) {
    st[i].marked = 1;
    swap(st[i].ma['0'], st[i].ma['1']);
}

void push(int i) {
    if(st[i].marked) {
        app(2*i);
        app(2*i+1);
        st[i].marked = 0;
    }
}

void update(int l1, int r1, int i = 1, int l2 = 0, int r2 = n-1) {
    if(l1 <= l2 && r2 <= r1) {
        app(i);
        return;
    }

    push(i);
    int m2 = (l2 + r2) / 2;

    if(l1 <= m2)
        update(l1, r1, 2*i, l2, m2);
    if(m2+1 <= r1)
        update(l1, r1, 2*i+1, m2+1, r2);

    st[i].ma = st[2*i].ma;
    st[i].ma['0'] += st[2*i+1].ma['0'];
    st[i].ma['1'] += st[2*i+1].ma['1'];
}

void resi() {
    build();

    for(int i = 0; i < q; ++i) {
        int l = kveri[i].fi, r = kveri[i].se;
        --l, --r;
        update(l, r);
        cout << st[1].ma['1'] << nl;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //idemo na podzadatke jej!
    //prvi deo je c je jednako n (u ovom nikada necemo okrenuti ceo niz)
    //drugi deo je c je jednako 1 (u ovom brojimo koliko ima blokova)
    //treci deo je l = r

    cin >> n >> c >> q;
    cin >> s;
    kveri.resize(q);

    for(auto &z : kveri)
        cin >> z.fi >> z.se;

    if(c == n) {
        resi();
        return 0;
    }

    cout << "Koji bruh momenat" << nl;
}